HDU 5433

每次BC都好心酸。。。

BFS+queue。。状态可以设为p_val[x][y][k],加上斗志的值。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
using namespace std;

char str[55];
int h[55][55];
double p_val[55][55][55];
bool vis[55][55][55];

struct Point{
	int x,y,k;double p;
	Point(){}
	Point(int xx,int yy,int kk,double pp){
		x=xx,y=yy,p=pp;k=kk;
	}
	bool operator<(const Point &a)const{
		if(p>a.p)return true;
		else if(p==a.p){
			if(k<a.k) return true;
		}
		return false;
	}
};

int dir[4][2]={
	{0,1},
		{0,-1},
			{1,0},
				{-1,0}
};

int bx,by,ex,ey;
priority_queue<Point>que;

void slove(int n,int m,int k,Point bt){
	memset(vis,false,sizeof(vis));
	Point tmp;
	//priority_queue<Point>que;
	que.push(bt);
	bool flag=false;
	while(!que.empty()){
		bt=que.top();
		que.pop();
		if(vis[bt.x][bt.y][bt.k]) continue;
		vis[bt.x][bt.y][bt.k]=true;

	//	cout<<bt.p<<endl;
		if(bt.p>p_val[bt.x][bt.y][bt.k]&&bt.k<=1) continue;
		for(int i=0;i<4;i++){
			tmp.x=dir[i][0]+bt.x;
			tmp.y=dir[i][1]+bt.y;
			if(tmp.x>=1&&tmp.x<=n&&tmp.y>=1&&tmp.y<=m&&h[tmp.x][tmp.y]!=-1){
				tmp.p=bt.p+fabs(h[bt.x][bt.y]-h[tmp.x][tmp.y])/(bt.k*1.0);
				tmp.k=bt.k-1;
			//	cout<<tmp.p<<endl;
				if(tmp.p<p_val[tmp.x][tmp.y][tmp.k]&&abs(ex-tmp.x)+abs(ey-tmp.y)<tmp.k){
					p_val[tmp.x][tmp.y][tmp.k]=tmp.p;
					que.push(tmp);
				}
			}
		}
	}
	double ans=1e10;
	for(int i=1;i<=k;i++)
		ans=min(ans,p_val[ex][ey][i]);
	if(ans==1e10)
		puts("No Answer");
	else printf("%.2f\n",ans);
}

int main(){
	int T,n,m,k;
	scanf("%d",&T);
	while(T--){
		while(!que.empty())que.pop();
		scanf("%d%d%d",&n,&m,&k);
		for(int i=1;i<=n;i++){
			scanf("%s",str+1);
			for(int j=1;j<=m;j++){
				for(int s=0;s<=k;s++) p_val[i][j][s]=1e10;
				if(str[j]==‘#‘)
					h[i][j]=-1;
				else{
					h[i][j]=str[j]-‘0‘;
				}
			}
		}
		scanf("%d%d",&bx,&by);
		scanf("%d%d",&ex,&ey);
		if(abs(ex-bx)+abs(ey-by)>k||k==0){
			puts("No Answer");
			continue;
		}
		if(bx==ex&&by==ey){
			puts("0.00");
		}
		else{
			slove(n,m,k,Point(bx,by,k,0));
		}

	}
	return 0;
}
时间: 2024-10-20 11:41:00

HDU 5433的相关文章

hdu 5433 Xiao Ming climbing(bfs+三维标记)

Problem Description Due to the curse made by the devil,Xiao Ming is stranded on a mountain and can hardly escape. This mountain is pretty strange that its underside is a rectangle which size is n∗m and every little part has a special coordinate(x,y)a

hdu 5433 Xiao Ming climbing(用dp代替搜索)

题意:有n*m的矩阵,人的初始力量值为k,矩阵上有数字表示高度,相邻点高度差的绝对值除k,为力量消耗量,求给定起点终点消耗力量的最小值: 思路:dp[k][x][y]表示第k步走到(x,y)时的最小力量消耗,建立递推: #include<cstdio> #include<cmath> #include<cstring> #include<algorithm> using namespace std; #define inf 0x3f3f3f3f int t,

hdu 5433 Xiao Ming climbing (BFS)

DFS超时,当时头脑混乱不会改成BFS.过了两天,思路清晰,一次AC,真爽. 思路:用dp[x][y][p]表示走到(x,y)且剩余斗志为p的最少体力,bfs的过程中,只有满足边界条件并且下一步算出来的值要小于dp[next.x][next.y][next.p]时才把这个点放入队列. #include <algorithm> #include <iostream> #include <cstring> #include <cstdio> #include &

hdu 5433 Xiao Ming climbing

题意:一张图,给出起点和终点,给一个fighting值,每走一步fighting消耗1,并且消耗(abs(H1−H2))/fighting 的 physical power.求起点到终点消耗最小的physical pow. 解:题目上有一句"At the biginning Xiao Ming has a fighting will k,if it turned to 0 Xiao Ming won't be able to fight with the devil,that means fai

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是